<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <title>Vozão Digital - Partner API Test</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.14.7/dist/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    <script>
      let accessToken;
      function showMessage(msg) {
        const modal = document.getElementById('errorModal');
        const modalTitle = modal.querySelector('.modal-title');
        const modalBody = modal.querySelector('.modal-body');
        modalTitle.textContent = 'Atenção';
        modalBody.innerHTML = '<p>'+msg+'</p>';
        $(modal).modal('show');
      }
      
      async function authenticate() {
        var url = document.getElementById("urlTxt").value;
        var service = document.getElementById("serviceTxt").value;
        var login = document.getElementById("loginTxt").value;
        var password = document.getElementById("passwordTxt").value;
        var data = {
          "service": service,
          "login": login,
          "password": password
        };
        try {
          const res = await fetch(url + "/partner/token", {
            method: "POST",
            body: JSON.stringify(data),
            headers: {
              "Content-Type": "application/json"
            }
          });          
          const json = await res.json();
          accessToken = json.accessToken;
          if (res.ok) {
            if (accessToken) {
              showMessage('Autenticado com sucesso!');
            } else {
              showMessage('Erro autenticando: ' + json.message);
            }
            console.log(accessToken);
          } else {
            showMessage('Erro autenticando: ' + (json.message || res.message));
          }
        } catch (err) {
          showMessage(err);
        }
      }
      async function sendNotification() {
        var url = document.getElementById("urlTxt").value;
        var group = document.getElementById("groupTxt").value;
        var email = document.getElementById("emailTxt").value;
        var cpf = document.getElementById("cpfTxt").value;
        var title = document.getElementById("titleTxt").value;
        var body = document.getElementById("bodyTxt").value;
        var data = {
          "to": {
            "broadcastTopic": group,
            "userEmail": email,
            "userDocument": cpf,
          },
          "title": title,
          "body": body,
          schedule: null
        };
        try {
          const res = await fetch(url + "/partner/push-notification/send", {
            method: "POST",
            body: JSON.stringify(data),
            headers: {
              "Authorization": "Bearer " + accessToken, 
              "Content-Type": "application/json"
            }
          });          
          const json = await res.json();
          if (res.ok) {
            if (json.success) {
              showMessage('Enviado com sucesso!');
            } else {
              showMessage('Erro enviando: ' + json.message);
            }
            console.log(accessToken);
          } else {
            showMessage('Erro enviando: ' + (json.message || json.error.code || res.message || res.status));
          }
        } catch (err) {
          showMessage(err);
        }     
      }

    </script>
  </head>
  <body>
    <nav class="navbar navbar-light bg-light">
      <a class="navbar-brand" href="#">
        <b>Vozão Digital - Partner API Test</b>
      </a>
    </nav>
    <div class="container" style="padding: 24px;">
      <div class="row">
        <div class="col">
          <div class="card">
            <div class="card-header">
              <b>Autenticação</b>
            </div>
            <div class="card-body">
              <div class="row">
                <div class="col">
                  <div class="form-group">
                    <label for="urlTxt">API Base URL</label>
                    <input type="email" class="form-control" id="urlTxt" placeholder="Enter URL" value="https://staging-partner-api.vozaodigital.com">
                  </div>
                </div>
                <div class="col">
                  <div class="form-group">
                    <label for="serviceTxt">Service</label>
                    <input class="form-control" id="serviceTxt" value="9d6da491-a859-45f3-b5e4-a4e5224dd157">
                  </div>      
                </div>
              </div>
              <div class="row">
                <div class="col">
                  <div class="form-group">
                    <label for="loginTxt">Login</label>
                    <input class="form-control" id="loginTxt" value="">
                  </div>      
                </div>
                <div class="col">
                  <div class="form-group">
                    <label for="passwordTxt">Password</label>
                    <input type="password" class="form-control" id="passwordTxt" placeholder="Password" value="">
                  </div>      
                </div>
              </div>
            </div>
            <div class="card-footer" style="text-align: right;">
              <button onclick="authenticate()" type="submit" class="btn btn-primary">Autenticar</button>
            </div>
          </div>
          <hr/>
          <div class="card">
            <div class="card-header">
              <b>Enviar Notificação</b>
            </div>
            <div class="card-body">
              <b>Enviar Para:</b>
              <div class="row">
                <div class="col">
                  <div class="form-group">
                    <label for="groupTxt">Grupo</label>
                    <input class="form-control" id="groupTxt">
                  </div>      
                </div>
                <div class="col">
                  <div class="form-group">
                    <label for="emailTxt">E-mail</label>
                    <input class="form-control" id="emailTxt">
                  </div>      
                </div>
                <div class="col">
                  <div class="form-group">
                    <label for="cpfTxt">CPF</label>
                    <input class="form-control" id="cpfTxt">
                  </div>      
                </div>
              </div>
              <hr/>
              <div class="form-group">
                <label for="titleTxt">Título</label>
                <input class="form-control" id="titleTxt" placeholder="Título">
              </div>      
              <div class="form-group">
                <label for="bodyTxt">Corpo</label>
                <input class="form-control" id="bodyTxt" placeholder="Corpo">
              </div>      
            </div>
            <div class="card-footer" style="text-align: right">
              <button type="submit" onclick="sendNotification()" class="btn btn-primary">Enviar</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="modal fade" id="errorModal" tabindex="-1" role="dialog" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Atenção</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <p id="errorMessage"></p>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Fechar</button>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>
<script>